package standard_deviation_calculator;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.ArrayList;
import javax.swing.Box;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

/**
 *
 * @author Vincent
 */
public class Standard_Deviation_Calculator {

    public static double mean = 0;
    public static double thirdPart = 0;
    public static ArrayList<Double> dataPoint = new ArrayList<>();
    public static ArrayList<Double> dataPointModified = new ArrayList<>();
    public static ArrayList<Double> dataPointModified_2 = new ArrayList<>();

    public static void main(String[] args) throws ClassNotFoundException, InstantiationException, IllegalAccessException, UnsupportedLookAndFeelException {
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        JFrame window = new JFrame("Standard Deviation Calculator");
        window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        final hullabalooButton calculate = new hullabalooButton("Calculate");
        final hullabalooButton addElementButton = new hullabalooButton("Add Element");
        final hullabalooButton removeElement = new hullabalooButton("Remove Previous");
        removeElement.setEnabled(false);
        addElementButton.setToolTipText("key shortcut ('enter')");
        removeElement.setToolTipText("key shortcut ('delete')");
        final JTextField addElement = new JTextField(10);
        JLabel dataList = new JLabel();
        dataList.setText("<html>No elements</html><html>Coolio</html>");
        JPanel center = new JPanel(new BorderLayout());
        JLabel finalData = new JLabel();
        JPanel top = new JPanel();
        calculate.addActionListener(new ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent e) {
                /*
                 Part 1
                 */
                int l = 0;
                double tempTotal = 0;
                while (l != dataPoint.size()) {
                    tempTotal = tempTotal + dataPoint.get(l);
                    l += 1;
                }
                mean = tempTotal / 4;
                mean = Math.round(mean * 100.0) / 100.0;
                /*
                 Part 2
                 */
                int l2 = 0;
                while (l2 != dataPoint.size()) {
                    double tempVar = dataPoint.get(l2) - mean;
                    tempVar = Math.round(tempVar * 100.0) / 100.0;
                    dataPointModified.add(tempVar);
                    l2 += 1;
                }
                System.out.println(dataPointModified);
                /*
                 Part 3
                 */
                int l3 = 0;
                while (l3 != dataPoint.size()) {
                    double tempVar = Math.pow(dataPointModified.get(l3), 2);
                    tempVar = Math.round(tempVar * 100.0) / 100.0;
                    dataPointModified_2.add(tempVar);
                    l3 += 1;
                }
                System.out.println(dataPointModified_2);
                int l4 = 0;
                double tempTotal2 = 0;
                while (l4 != dataPointModified_2.size()) {
                    tempTotal2 = tempTotal2 + dataPointModified_2.get(l4);
                    l4 += 1;
                }
                thirdPart = tempTotal2;
                System.out.println(tempTotal2);
                /*
                 Part 4 (final part)
                 */
                int nValue = dataPoint.size() - 1;
                double standard_deviation = Math.sqrt(thirdPart / nValue);
                standard_deviation = Math.round(standard_deviation * 100.0) / 100.0;
                System.out.println(standard_deviation);
                finalData.setText("<html><b>Standard Deviation: </b>" + standard_deviation + ""
                        + "<br><b>x: </b>" + dataPoint + "<br><b>x-x̅: </b>" + dataPointModified
                        + "<br><b>(x - x̅)^2: </b>" + dataPointModified_2 + "</html>");
            }
        });
        addElementButton.addActionListener(new ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent e) {
                dataPoint.add(Double.parseDouble(addElement.getText()));
                addElement.setText("");
                dataList.setText("<html>" + dataPoint + "</html>");
                removeElement.setEnabled(true);
            }
        });
        removeElement.addActionListener(new ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent e) {
                if (removeElement.isEnabled()) {
                    dataPoint.remove(dataPoint.size() - 1);
                    dataList.setText("<html>" + dataPoint + "</html>");
                    if (dataPoint.size() == 0) {
                        removeElement.setEnabled(false);
                        dataList.setText("<html>No elements</html><html>Coolio</html>");
                    }
                }
            }
        });
        KeyListener keyListener = new KeyListener() {
            public void keyPressed(KeyEvent keyEvent) {
                int keyCode = keyEvent.getKeyCode();
                String kt = Character.toString(keyEvent.getKeyChar());
                if (keyEvent.getKeyCode() == KeyEvent.VK_ENTER) {
                    addElementButton.doClick();
                }
                if (keyEvent.getKeyCode() == KeyEvent.VK_DELETE) {
                    removeElement.doClick();
                }
                if (keyEvent.getKeyCode() == KeyEvent.VK_ESCAPE) {
                    dataPoint.clear();
                    dataList.setText("<html>No elements</html><html>Coolio</html>");
                    addElement.setText("");
                }
            }

            public void keyReleased(KeyEvent keyEvent) {
            }

            public void keyTyped(KeyEvent keyEvent) {
            }
        };
        addElement.addKeyListener(keyListener);
        top.add(Box.createHorizontalGlue());
        top.add(addElement);
        top.add(addElementButton);
        top.add(removeElement);
        top.add(calculate);
        center.add(BorderLayout.CENTER, finalData);
        window.add(BorderLayout.NORTH, top);
        window.add(BorderLayout.CENTER, center);
        window.add(BorderLayout.SOUTH, dataList);
        window.setSize(500, 300);
        window.setMinimumSize(new Dimension(500, 300));
        java.net.URL imageURL = Standard_Deviation_Calculator.class.getResource("programIcon.png");
        if (imageURL != null) {
            window.setIconImage(Toolkit.getDefaultToolkit().getImage(imageURL));

        }
        window.setVisible(true);
        window.setLocationRelativeTo(null);
    }
}
