package standard_deviation_calculator;

import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import javax.swing.JButton;

/**
 *
 * @author Vincent
 */
public class hullabalooButton extends JButton {

    public hullabalooButton(String title) {
        setText(title);
        setContentAreaFilled(false);
        setFocusPainted(false);
        setForeground(Color.WHITE);
    }

    @Override
    protected void paintComponent(Graphics g) {
        Graphics2D g2 = (Graphics2D) g.create();
        g2.setPaint(new GradientPaint(
                new Point(0, 0),
                Color.BLUE.brighter(),
                new Point(0, getHeight()),
                Color.BLUE.darker()));
        g2.fillRect(0, 0, getWidth(), getHeight());
        g2.dispose();
        super.paintComponent(g);
    }
}
